//+------------+-----------------------------------------------------+
//| v.16.08.08 |                            ImposingCandleSticks.mq4 |
//|            |              Bookkeeper, 2008, yuzefovich@gmail.com |
//+------------+-----------------------------------------------------+
// imposing -     :
// , , , , ,..
//     .
/*-------------------------------------------------------------------+
   
    ,     :)
   
       ,  ,    
    :
   1.  :
   1.1.          
     Forex (    ).
   1.2.       
            (
      )     Forex (
      ).
   1.3.  (   )    
        ,   
       .
   2.   :
   2.1.          
     ,  ,    1.1
    1.2.
   2.2.  (        ex4-)
          (     ).
   
    :)   !      !
         -   ,  .
            
   ,    ,    .

                                                        Bookkeeper

  +-----------------------------------------------------------------*/
#property copyright ""
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Blue
#property indicator_color2  Blue
#property indicator_color3  Red
#property indicator_color4  Green
#property indicator_color5  Navy
#property indicator_color6  Blue
#property indicator_color7  Blue
#property indicator_color8  Blue
//----
extern int SnakeRange =2;        //  =5 !    
//----                                      
double SnakeHigh[];
double SnakeLow[];
double SnakeOpen[];
double SnakeClose[];
double Navel[];
double SnakeHL[];
double SnakeCHL[];
double SnakeC2HL[];
//----
                                  // 0 - Close
                                  // 1 - Open
                                  // 2 - High
                                  // 3 - Low
//----
double SnakeHead[6]={0,0,0,0,0,0};
//---------------------------------------------------------------------
double Price(int CALC_MODE, int Shift)
{
   switch(CALC_MODE)
   {
     case  0:
      return(Close[Shift]);
     case  1:
      return(Open[Shift]);
     case  2:
      return(High[Shift]);
     case  3:
      return(Low[Shift]);
     default:
      return(Close[Shift]);
   }
}
//---------------------------------------------------------------------
double CalcSnakeTail(int CALC_MODE, int Pos)
{  
   int Shift=Pos+SnakeRange;
   double SnakeSum=0.0;
   int SnakeWeight=0;
   for(int i=0;i<SnakeRange;i++)
   {
      SnakeSum=SnakeSum+(Price(CALC_MODE,Pos+SnakeRange-i)+
                         Price(CALC_MODE,Pos-SnakeRange+i))*(i+1);
      SnakeWeight=SnakeWeight+(i+1)*2;
   }
   SnakeSum=SnakeSum+Price(CALC_MODE, Pos)*(SnakeRange+1);
   SnakeWeight=SnakeWeight+SnakeRange+1;
   return(SnakeSum/SnakeWeight);
}
//---------------------------------------------------------------------
void CalcSnakeHead(int CALC_MODE)
{  
   int Shift=0,i;
   double SnakeSum=0.0;
   int SnakeWeight=0;
   switch(CALC_MODE) 
   {
      case  0: 
         SnakeHead[0]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_CLOSE,0);
         break;
      case  1: 
         SnakeHead[0]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_OPEN,0);
         break;
      case  2: 
         SnakeHead[0]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_HIGH,0);
         break;
      case  3: 
         SnakeHead[0]=iMA(NULL,0,SnakeRange+1,0,MODE_LWMA,PRICE_LOW,0);
         break;
      default:
         SnakeSum=0.0;
         SnakeWeight=0;
         i=0;
         for(Shift=SnakeRange;Shift>=0;Shift--)
         {
            i++;
            SnakeSum=SnakeSum+i*Price(CALC_MODE,Shift);
            SnakeWeight=SnakeWeight+i;
         }
         SnakeHead[0]=SnakeSum/SnakeWeight;
         break; 
   }
   for(Shift=SnakeRange;Shift>0;Shift--)
   {
      SnakeSum=0.0;
      SnakeWeight=0;
      i=0;
      int w=Shift+SnakeRange;
      int ww=Shift-SnakeRange;
      if(ww<0) ww=0;
      while(w>=Shift)
      {
         i++;
         SnakeSum=SnakeSum+i*Price(CALC_MODE,w);
         SnakeWeight=SnakeWeight+i;
         w--;
      }
      while(w>=ww)
      {
         i--;
         SnakeSum=SnakeSum+i*Price(CALC_MODE,w);
         SnakeWeight=SnakeWeight+i;
         w--;
      }
      SnakeHead[Shift]=SnakeSum/SnakeWeight;
   }
   return;
}
//---------------------------------------------------------------------
void deinit()
{
  return;
}
//---------------------------------------------------------------------
int init()
{
   IndicatorBuffers  (8);
   SetIndexBuffer    (0,SnakeHigh);
   SetIndexBuffer    (1,SnakeLow);
   SetIndexBuffer    (2,SnakeOpen);
   SetIndexBuffer    (3,SnakeClose);
   SetIndexBuffer    (4,Navel);
   SetIndexBuffer    (5,SnakeHL);
   SetIndexBuffer    (6,SnakeCHL);
   SetIndexBuffer    (7,SnakeC2HL);
   SetIndexStyle     (0,DRAW_HISTOGRAM);
   SetIndexStyle     (1,DRAW_HISTOGRAM);
   SetIndexStyle     (2,DRAW_HISTOGRAM,EMPTY,3);
   SetIndexStyle     (3,DRAW_HISTOGRAM,EMPTY,3);
   SetIndexStyle     (4,DRAW_NONE);//LINE,EMPTY,2);
   SetIndexStyle     (5,DRAW_NONE);//LINE,EMPTY,2);
   SetIndexStyle     (6,DRAW_NONE);//LINE,EMPTY,2);
   SetIndexStyle     (7,DRAW_NONE);//LINE,EMPTY,2);
   return(0);
}
//---------------------------------------------------------------------
int start()
{
   for(int i=0;i<6;i++) SnakeHead[i]=0;
   int counted_bars=IndicatorCounted();
   if(Bars<=(SnakeRange+2)) return(-1);
   if(SnakeRange<1) SnakeRange=1;
   if(counted_bars<0)  return(-1);
   if(counted_bars>0)  counted_bars--;
   int limit=Bars-counted_bars;
   if(limit>Bars-(SnakeRange+2)) limit=Bars-(SnakeRange+2);
   if(limit<=SnakeRange) limit=SnakeRange+1;
   for(i=limit;i>=SnakeRange;i--)
   {
      SnakeHigh[i]=CalcSnakeTail(2,i);
      SnakeLow[i]=CalcSnakeTail(3,i);
      SnakeClose[i]=CalcSnakeTail(0,i);
      SnakeOpen[i]=CalcSnakeTail(1,i);
      Navel[i]=(SnakeClose[i]*5+
                SnakeOpen[i]*2+
                SnakeHigh[i]+
                SnakeLow[i])/9;
      SnakeHL[i]=(SnakeHigh[i]+
                  SnakeLow[i])/2;
      SnakeCHL[i]=(SnakeClose[i]+
                   SnakeHigh[i]+
                   SnakeLow[i])/3;
      SnakeCHL[i]=(SnakeClose[i]*2+
                   SnakeHigh[i]+
                   SnakeLow[i])/4;
   }
   CalcSnakeHead(2);
   for(i=SnakeRange;i>=0;i--) SnakeHigh[i]=SnakeHead[i];
   CalcSnakeHead(3);
   for(i=SnakeRange;i>=0;i--) SnakeLow[i]=SnakeHead[i];
   CalcSnakeHead(0);
   for(i=SnakeRange;i>=0;i--) SnakeClose[i]=SnakeHead[i];
   CalcSnakeHead(1);
   for(i=SnakeRange;i>=0;i--) SnakeOpen[i]=SnakeHead[i];
   for(i=SnakeRange;i>=0;i--)
   {
      Navel[i]=(SnakeClose[i]*5+
                SnakeOpen[i]*2+
                SnakeHigh[i]+
                SnakeLow[i])/9;
      SnakeHL[i]=(SnakeHigh[i]+
                  SnakeLow[i])/2;
      SnakeCHL[i]=(SnakeClose[i]+
                   SnakeHigh[i]+
                   SnakeLow[i])/3;
      SnakeCHL[i]=(SnakeClose[i]*2+
                   SnakeHigh[i]+
                   SnakeLow[i])/4;
   }
   return(0);
}
//---------------------------------------------------------------------

